import type { Component } from 'vue'

export interface IMenuItem {
  tag?: string
  name: string
  path: string
  icon?: Component
  children?: IMenuItem[]
}

// 用户信息
export interface UserType {
  id: string
  mobile: string
  name: string
  email: string
  username: string
  avatar: string
}

// 项目信息
export interface ProjectType {
  id: string
  tab: string
  name: string
}

// 机构信息
export interface OrganizationType {
  id: string
  name: string
  contact_name: string
  contact_information: string
  validity_date: string
  is_valid: 1 | 2
}

// 角色信息
export interface RoleType {
  id: string
  name: string
  desc: string
}

// 权限信息
export interface PermissionType {
  desc: string
  effect_uris: string
  id: string
  name: string
  parent_id: string
  system_tag: number
  type: number
  tag: string
}

// 课程信息
export interface CourseType {
  id: string
  course_id: string
  semester_id: string
  schedule: string
  represent: string
  watch_video_length: number
  is_finished: number
  is_top: number
  name: string
  cover: string
  elective_type: number
  online_type: number
  section?: ChapterType
  semester: SemesterType
  credit: number
  previous_preparation: string
  target: string
  lecturers?: LecturerType[]
}

// 章节信息
export interface ChapterType {
  id: string
  name: string
  schedule: string
  watch_video_length: number
  is_finished: number
}

// 学期信息
export interface SemesterType {
  id: string
  name: string
  start_time?: string
  end_time?: string
}

export interface LecturerType {
  id: string
  name: string
  avatar: string
  summarize: string
}
